	CODE32
	AREA code_start, CODE, READONLY


	IMPORT |Load$$IRAM$$Base| 	; End of ROM code (=start of ROM data)
	IMPORT |Image$$IRAM$$Base| 	; Base of RAM to initialize
	IMPORT |Image$$IRAM$$Limit| 	; Base and limit of area

;	IMPORT |Load$$ERAM$$Base| 	; End of ROM code (=start of ROM data)
;	IMPORT |Image$$ERAM$$Base| 	; Base of RAM to initialize
;	IMPORT |Image$$ERAM$$Limit| 	; Base and limit of area

	IMPORT |Image$$IRAM$$ZI$$Base| 	; to zero initialize
	IMPORT |Image$$IRAM$$ZI$$Limit| 	; to zero initialize	

;	IMPORT |Image$$ERAM$$ZI$$Base| 	; to zero initialize
;	IMPORT |Image$$ERAM$$ZI$$Limit| 	; to zero initialize	


	IMPORT AgbMain

Cpu_Mode_USR	EQU 	0x10
Cpu_Mode_IRQ 	EQU 	0x12
Cpu_Mode_SVC 	EQU 	0x13

Cpu_Stack_USR	EQU	0x03007F00	; GBA USR stack adress
Cpu_Stack_IRQ	EQU	0x03007FA0	; GBA IRQ stack adress
Cpu_Stack_SVC	EQU	0x03007FE0	; GBA SVC stack adress

	ENTRY
	b 	start
                DCB     0x24,0xFF,0xAE,0x51,0x69,0x9A,0xA2,0x21
                DCB     0x3D,0x84,0x82,0x0A,0x84,0xE4,0x09,0xAD
                DCB     0x11,0x24,0x8B,0x98,0xC0,0x81,0x7F,0x21
                DCB     0xA3,0x52,0xBE,0x19,0x93,0x09,0xCE,0x20
                DCB     0x10,0x46,0x4A,0x4A,0xF8,0x27,0x31,0xEC
                DCB     0x58,0xC7,0xE8,0x33,0x82,0xE3,0xCE,0xBF
                DCB     0x85,0xF4,0xDF,0x94,0xCE,0x4B,0x09,0xC1
                DCB     0x94,0x56,0x8A,0xC0,0x13,0x72,0xA7,0xFC
                DCB     0x9F,0x84,0x4D,0x73,0xA3,0xCA,0x9A,0x61
                DCB     0x58,0x97,0xA3,0x27,0xFC,0x03,0x98,0x76
                DCB     0x23,0x1D,0xC7,0x61,0x03,0x04,0xAE,0x56
                DCB     0xBF,0x38,0x84,0x00,0x40,0xA7,0x0E,0xFD
                DCB     0xFF,0x52,0xFE,0x03,0x6F,0x95,0x30,0xF1
                DCB     0x97,0xFB,0xC0,0x85,0x60,0xD6,0x80,0x25
                DCB     0xA9,0x63,0xBE,0x03,0x01,0x4E,0x38,0xE2
                DCB     0xF9,0xA2,0x34,0xFF,0xBB,0x3E,0x03,0x44
                DCB     0x78,0x00,0x90,0xCB,0x88,0x11,0x3A,0x94
                DCB     0x65,0xC0,0x7C,0x63,0x87,0xF0,0x3C,0xAF
                DCB     0xD6,0x25,0xE4,0x8B,0x38,0x0A,0xAC,0x72
                DCB     0x21,0xD4,0xF8,0x07



                ; Note: The title MUST have 12 characters. You can of course use spaces at the end. 
                        ;123456789012
                DCB     "MandelBoyGBA"

                DCB     "lupi" ;creator

                DCB     0x00,0x00

                DCB     0x96 ;96h

                DCB     0x00

                DCB     0x00

                DCB     0x00,0x00,0x00,0x00,0x00,0x00,0x00

                DCB     0x00

                ; Complement check - use gbafix to determine your complement ( e.g. gbafix -v yourgame.agb ) and insert it here
                DCB     0x62

                DCB     0x00,0x00          

start
	mov 	r0, #Cpu_Mode_IRQ:OR:0x80:OR:0x40 	; Disable interrupts
	msr 	CPSR_c, r0					; Enable IRQ mode
	ldr 	r13, =Cpu_Stack_IRQ			; Setup IRQ stack pointer

	mov 	r0, #Cpu_Mode_SVC:OR:0x80:OR:0x40 	; Disable interrupts
	msr 	CPSR_c, r0					; Enable SVC mode
	ldr 	r13, =Cpu_Stack_SVC			; Setup SVC stack pointer


	ldr 	r0, =|Load$$IRAM$$Base| 	; Get pointer to ROM data
	ldr 	r1, =|Image$$IRAM$$Base| 		; and RAM copy
	ldr 	r3, =|Image$$IRAM$$Limit| 		; Zero init base => top of initialized data
    ;IRAM in speicher kopieren
0 	cmp 	r1, r3 				; Copy init data
	ldrlt 	r2, [r0], #4
	strlt 	r2, [r1], #4
	blt	%B0

;	ldr 	r0, =|Load$$ERAM$$Base| 	; Get pointer to ROM data
;	ldr 	r1, =|Image$$ERAM$$Base| 		; and RAM copy
;	ldr 	r3, =|Image$$ERAM$$Limit| 		; Zero init base => top of initialized data
;    ;IRAM in speicher kopieren
;1 	cmp 	r1, r3 				; Copy init data
;	ldrlt 	r2, [r0], #4
;	strlt 	r2, [r1], #4
;	blt	%B1


	ldr 	r0, =|Image$$IRAM$$ZI$$Base| 	; Top of zero init segment
	ldr 	r1, =|Image$$IRAM$$ZI$$Limit| 	; Top of zero init segment
	mov 	r2, #0
2 	cmp 	r0, r1 				; Zero init
	strlt 	r2, [r0], #4
	blt	%B2

;	ldr 	r0, =|Image$$ERAM$$ZI$$Base| 	; Top of zero init segment
;	ldr 	r1, =|Image$$ERAM$$ZI$$Limit| 	; Top of zero init segment
;	mov 	r2, #0
;3 	cmp 	r0, r1 				; Zero init
;	strlt 	r2, [r0], #4
;	blt	%B3



	mov 	r0, #Cpu_Mode_SVC:OR:0x40	; Only IRQ enabled
	msr 	CPSR_c, r0

	mov 	r0, #Cpu_Mode_USR:OR:0x40	;
	msr 	CPSR_c, r0					; Switch to USR mode
	ldr 	sp, =Cpu_Stack_USR			; Setup USR stack pointer
    
    ldr     r0,=AgbMain       ; Jump to Thumb code.
    bx      r0

 	END
 	